

// q1
interface Interesting {
    public boolean isInteresting(Object o);
}


// q4
interface Compute {
    public Object compute(Object o);
}


// q2
class Even implements Interesting {
    public boolean isInteresting(Object o){
        int n = (Integer)o;
        if(n % 2 == 0)
            return true;
        return false;
    }
}

// q3
class Capitalized implements Interesting {
    public boolean isInteresting(Object o){
        String s = (String)o;
        if(s.charAt(0) >= 'A' && s.charAt(0) <= 'Z')
            return true;
        return false;
    }
}


public class Quiz20091016 {

    // q1
    public static Object[] grep(Interesting f,Object[] o){
        // declare some data store.
        MyList a = new MyList(o.length + 100);
        // loop through the array.
        for(int i=0;i<o.length;i++){
            // if entry is interesting.
            if(f.isInteresting(o[i]))
                a.push(o[i]);   // add it to data store.
        }
        // declare output array 
        Object[] out = new Object[a.size()];
        // copy data store to output
        for(int i=0;i<out.length;i++)
            out[i] = a.get(i);
        return out; // return output array.
    }

    // q5
    public static Object[] map(Compute f,Object[] o){
        Object[] out = new Object[o.length];
        for(int i=0;i<o.length;i++)
            out[i] = f.compute(o[i]);
        return out;
    }

    // test code.
    public static void main(String[] args) {

        // q2
        Object[] arr = new Object[30];
        System.out.print("original list: ");
        for(int i=0;i<arr.length;i++){
            arr[i] = (int)(Math.random()*100);
            System.out.print(""+arr[i]+", ");
        }
        Even evenImpl = new Even();
        Object[] e = grep(evenImpl,arr);
        System.out.print("\nout list: ");
        for(int i=0;i<e.length;i++){
            System.out.print(""+e[i]+", ");
        }
        System.out.println("\n");

        // q5 test code
        Object[] p = map(new Compute(){
            public Object compute(Object o){
                int n = (Integer)o;
                return n*n;
            }
        },arr);
        System.out.print("\nout powers list: ");
        for(int i=0;i<p.length;i++){
            System.out.print(""+p[i]+", ");
        }
        System.out.println("\n");
        

        // q3 (strings)
        String[] lnames = {"Doe","Smith","Williams","Jefferson","Washington","Clinton","Bush"};
        String[] fnames = {"John","Jane","Hillary","George","Bobby"};
        String[] names = new String[50];
        for(int i=0;i<names.length;i++){
            names[i] = fnames[(int)(Math.random()*fnames.length)]+" "+lnames[(int)(Math.random()*lnames.length)];
            if(Math.random()<0.5){  // coin flip?
                names[i] = names[i].toLowerCase();
            }
        }
        System.out.print("original names list: ");
        for(int i=0;i<names.length;i++){
            System.out.print(""+names[i]+"; ");
        }
        System.out.println("\n\n");

        Object[] cnames = grep(new Capitalized(),names);
        System.out.print("out list: ");
        for(int i=0;i<cnames.length;i++){
            System.out.print(""+cnames[i]+"; ");
        }
        System.out.println("\n");
        
        // inline implementation of interface.
        Object[] rnames = grep(new Interesting(){
            public boolean isInteresting(Object o){
                String s = (String)o;
                if(s.toLowerCase().indexOf('r') >= 0)
                    return true;
                return false;
            }
        },names);
        System.out.print("out (rlist) list: ");
        for(int i=0;i<rnames.length;i++){
            System.out.print(""+rnames[i]+"; ");
        }
        System.out.println("\n");
        
        // display output using map
        System.out.print("map output: ");
        map(new Compute(){
            public Object compute(Object o){
                System.out.print(""+o+", ");
                return null;
            }
        },rnames);
        System.out.println("\n");
    }
}



